using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace _42189
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private Syncfusion.Windows.Forms.Grid.GridAwareTextBox gridAwareTextBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.SetUpArray();
			this.gridControl1.QueryCellInfo += new GridQueryCellInfoEventHandler(QueryCellInfoHandler);
			this.gridControl1.SaveCellInfo +=new GridSaveCellInfoEventHandler(SaveCellInfoHandler);
			this.gridControl1.QueryCellFormattedText += new GridCellTextEventHandler(gridControl1_QueryCellFormattedText);

			this.gridControl1.QueryColCount += new GridRowColCountEventHandler(GridQueryColCount);
			this.gridControl1.QueryRowCount += new GridRowColCountEventHandler(GridQueryRowCount);

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.gridAwareTextBox1 = new Syncfusion.Windows.Forms.Grid.GridAwareTextBox();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridControl1.Location = new System.Drawing.Point(8, 40);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(688, 192);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			// 
			// gridAwareTextBox1
			// 
			this.gridAwareTextBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.gridAwareTextBox1.DisabledBackColor = System.Drawing.SystemColors.Window;
			this.gridAwareTextBox1.EnabledBackColor = System.Drawing.SystemColors.Window;
			this.gridAwareTextBox1.Location = new System.Drawing.Point(482, 15);
			this.gridAwareTextBox1.Name = "gridAwareTextBox1";
			this.gridAwareTextBox1.Size = new System.Drawing.Size(208, 20);
			this.gridAwareTextBox1.TabIndex = 1;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(704, 238);
			this.Controls.Add(this.gridAwareTextBox1);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		int colCount=10, rowCount=10;
		private double [,] intArray;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.gridAwareTextBox1.WireGrid(this.gridControl1);
			this.gridControl1.Refresh();

		}

		private void SetUpArray()
		{
			this.Cursor = Cursors.WaitCursor;

			Random r = new Random();

			this.intArray = new double[rowCount, colCount];

			for (int i = 0; i < rowCount; ++i)
				for(int j = 0; j < colCount; ++j)
					this.intArray[i, j] = 0.005;//r.Next(10000);

			this.Cursor = Cursors.Arrow;
		}


		private void QueryCellInfoHandler(object sender, GridQueryCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
			{
				e.Style.Format ="N2";
				e.Style.CellValue = this.intArray[e.RowIndex - 1, e.ColIndex - 1];
				e.Handled = true;
			}
		}
		
		private void GridQueryColCount(object sender, GridRowColCountEventArgs e)
		{
			e.Count = colCount;
			e.Handled = true;
		}

		private void GridQueryRowCount(object sender, GridRowColCountEventArgs e)
		{
			e.Count = rowCount;
			e.Handled = true;
		}

		private void SaveCellInfoHandler(object sender, GridSaveCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
			{
				this.intArray[e.RowIndex - 1, e.ColIndex - 1] =Convert.ToInt32(e.Style.CellValue);// = value;
				e.Handled = true;
			}

		}

		private void gridControl1_QueryCellFormattedText(object sender, GridCellTextEventArgs e)
		{
			if(e.Value !=null&& e.TextInfo == GridCellBaseTextInfo.CurrentText)
			{ 
				e.Text = e.Style.Text; 
				e.Handled = true; 
			} 
		}
	}
}
